/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */

package mvcgrafik.controller;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import mvcgrafik.controller.commands.CommandInvoker;
import mvcgrafik.controller.commands.OpenCommand;
import mvcgrafik.controller.commands.PrintCommand;
import mvcgrafik.controller.commands.SaveCommand;
import mvcgrafik.model.GrafikModel;
import mvcgrafik.view.GrafikFrame;
import mvcgrafik.view.GrafikView;

/**
 *
 * @author ahren
 */
public class CommandController implements ActionListener
{
  private GrafikFrame frame;
  private GrafikView view;
  private GrafikModel model;
  private CommandInvoker invoker;
    
  public CommandController(GrafikFrame frame,GrafikView view, GrafikModel model)
  {
    this.frame = frame;
    this.view = view;
    this.model = model;
    this.invoker = new CommandInvoker();
  }

  public void registerEvents()
  {
    frame.getBtnFileOpen().addActionListener(this);
    frame.getBtnFileSave().addActionListener(this);
    frame.getBtnPrint().addActionListener(this);

  }
  
  public void registerCommands()
  {
    invoker.addCommand(frame.getBtnFileOpen(), new OpenCommand(frame, model));
    invoker.addCommand(frame.getBtnFileSave(), new SaveCommand(frame,model));
    invoker.addCommand(frame.getBtnPrint(), new PrintCommand(view,model));  

  }
  
    /**
     * Ausführen des jeweiligen Kommandos
     * @param e Referenz auf das Event
     */
    @Override
    public void actionPerformed(ActionEvent e) {
        Component key = (Component)e.getSource();
        invoker.executeCommand(key);
        if(key == frame.getBtnFileOpen()){
          invoker.deleteStack();
        }
    }
}
